<template>
  <div class="my-3 my-md-0">
    <div class="ml-n1 mb-2 text-secondary" :class="formClass">
      {{ $t('create_look') }}
    </div>
    <b-form autocomplete="off" class="w-100" @submit.prevent="onSubmit">
      <b-form-row class="filter-form">
        <b-form-group
          id="namebookGroupName"
          :label="$t('form.name')"
          label-for="namebookInputName"
          class="mb-3 mb-md-0 mr-md-3 small"
        >
          <b-form-input
            id="namebookInputName"
            v-model="form.name"
            type="text"
            @focus="onFocusInput('name')"
            @blur="isValidName"
          />
          <transition name="fade">
            <div v-if="validation.name" class="tooltip">
              {{ validation.name }}
            </div>
          </transition>
        </b-form-group>
        <b-form-group
          id="namebookGroupLanguage"
          :label="$t('form.language')"
          label-for="namebookSelectLanguage"
          class="mb-3 mb-md-0 mr-md-3 small"
        >
          <b-form-select
            id="namebookSelectLanguage"
            v-model="form.language"
            :options="languages"
          />
          <transition name="fade">
            <div v-if="validation.language" class="tooltip">
              {{ validation.language }}
            </div>
          </transition>
        </b-form-group>
        <div id="namebookCharacter" class="gender-group mb-3 mb-md-0 mr-md-3">
          <b-button
            v-for="(gender, index) in genders"
            :key="gender"
            :variant="form.gender === gender || (form.character && form.character.gender === gender) ? 'primary' : 'secondary'"
            :class="{'mx-2': index > 0 && index < genders.length - 1, 'ml-2': index === genders.length - 1, 'mr-2': !index}"
            @click="toggleGender(gender)"
          >
            {{ $t('form.' + gender) }}
          </b-button>
          <transition name="fade">
            <div v-if="validation.character" class="tooltip">
              {{ validation.character }}
            </div>
          </transition>
          <transition name="fade">
            <div
              v-if="filteredCharacters.length"
              class="gender-group__tooltip"
              :class="[form.gender === 'boy' ? 'gender-group__tooltip--start' : 'gender-group__tooltip--end']"
            >
              <p class="mb-3 text-center text-dark px-2 text-nowrap">
                {{ $t('form.choose_character') }}
              </p>
              <div class="d-flex flex-row justify-content-center px-3">
                <div
                  v-for="character in filteredCharacters"
                  :key="'character-' + character.id"
                  class="gender-group__tooltip__item"
                  :class="{'gender-group__tooltip__item--active': form.character && form.character.id === character.id}"
                  :style="{width: (100/filteredCharacters.length) + '%'}"
                  @click="selectCharacter(character)"
                >
                  <b-img :src="character.image | image" :alt="character.name" />
                </div>
              </div>
            </div>
          </transition>
        </div>

        <template v-if="formData">
          <b-button v-if="isIdenticalData" variant="danger" class="btn--right w-100" type="submit">
            {{ $t('close') }}
          </b-button>
          <b-button v-else variant="success" class="btn--right w-100" type="submit">
            {{ $t('edit') }}
          </b-button>
        </template>
        <b-button v-else variant="primary" class="btn--right w-100" type="submit">
          {{ $t('form.view_book') }}
        </b-button>
      </b-form-row>
    </b-form>
  </div>
</template>

<script>
import { mapActions } from 'vuex'

export default {
  name: 'NamebookForm',
  props: {
    book: {
      type: Object,
      required: true
    },
    formData: {
      type: Object,
      default: null
    },
    formClass: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      form: {
        name: '',
        language: '',
        character: '',
        gender: ''
      },
      validation: {
        name: '',
        language: '',
        character: ''
      },
      languages: [
        {
          text: this.$t('languages.ru'),
          value: 'ru'
        },
        {
          text: this.$t('languages.kk'),
          value: 'kk'
        }
      ],
      genders: ['boy', 'girl'],
      characters: []
    }
  },
  computed: {
    filteredCharacters () {
      if (this.characters.length && this.form.gender) {
        return this.characters.filter(service => service.gender === this.form.gender)
      }
      return []
    },
    isIdenticalData () {
      if (this.formData) {
        return this.form.name === this.formData.name &&
            this.form.language === this.formData.language &&
            this.form.gender === this.formData.gender &&
            this.form.character && this.form.character.id === this.formData.character.id
      }
      return false
    }
  },
  watch: {
    'form.gender' () {
      this.form.character = this.formData ? this.formData.character : ''
    },
    'validation.character' () {
      if (this.validation.character && this.form.gender) {
        this.form.gender = ''
      }
    },
    'form.language' () {
      if (this.validation.name) {
        this.isValidName()
      }
    }
  },
  mounted () {
    this.getCharacters()
    if (this.formData) {
      const {
        name,
        language,
        character,
        gender
      } = this.formData
      this.form = {
        name,
        language,
        character,
        gender
      }
    } else {
      this.form.language = this.$i18n.locale
    }
  },
  methods: {
    ...mapActions({
      setForm: 'book/SET_FORM'
    }),
    toggleGender (gender) {
      this.form.gender = this.form.gender === gender ? '' : gender
    },
    selectCharacter (character) {
      this.form.character = character
    },
    async getCharacters () {
      const { data } = await this.$axios.$get('namebooks/' + this.book.id + '/characters')
      this.characters = data
    },
    onSubmit () {
      if (this.isValidLanguage() && this.isValidName() && this.isValidCharacter()) {
        const form = Object.assign({}, this.form)
        form.book = {
          type: 'namebook',
          id: this.book.id
        }

        if (this.isIdenticalData) {
          this.$emit('hide')
        } else {
          this.setForm(form).then(() => {
            if (this.formData) {
              this.$emit('hide')
            } else {
              const path = this.localePath({
                name: 'namebooks-id-preview',
                params: { id: this.book.id }
              })
              this.$router.push({ path })
            }
          })
        }
      }
    },
    isValidName () {
      if (this.form.name) {
        const nameLength = this.form.name.length
        if (nameLength >= 3) {
          if (nameLength <= 10) {
            if (this.isAlphabetical(this.form.name, this.form.language)) {
              return true
            } else {
              this.validate('name', 'fill_language.text', { lang: this.$t('validation.fill_language.' + this.form.language) })
            }
          } else {
            this.validate('name', 'max', {
              field: this.$t('form.name').toLowerCase(),
              count: 10
            })
          }
        } else {
          this.validate('name', 'min', {
            field: this.$t('form.name').toLowerCase(),
            count: 3
          })
        }
      } else {
        this.validate('name', 'required', { field: this.$t('form.name').toLowerCase() })
      }
      return false
    },
    isValidLanguage () {
      if (this.form.language) {
        return true
      } else {
        this.validate('language', 'required', { field: this.$t('form.language').toLowerCase() })
      }
      return false
    },
    isValidCharacter () {
      if (this.form.character) {
        return true
      } else {
        this.validate('character', 'required_character')
      }
      return false
    },
    validate (fieldName, validation, payload) {
      this.validation[fieldName] = this.$t('validation.' + validation, payload)
    },
    isAlphabetical (string, lang) {
      if (lang === 'ru') {
        return /^[а-яА-ЯЁё]+$/.test(string)
      } else if (lang === 'latin') {
        return /^[a-zA-Z]+$/.test(string)
      } else if (lang === 'kk') {
        return /^[а-яА-ЯЁёӘәІіҢңҒғҮүҰұҚқӨөҺһ]+$/.test(string)
      }
      return false
    },
    onFocusInput (field) {
      if (this.validation[field]) {
        this.validation[field] = ''
      }
    }
  }
}
</script>

<style lang="scss">
    //noinspection CssUnknownTarget
    @import "@/assets/scss/_variables.scss";
    @import "~bootstrap/scss/mixins/breakpoints";

    .filter-form {
        display: flex;
        flex-direction: row;
        flex-wrap: nowrap;
        align-items: flex-end;
        .btn {
            white-space: nowrap;
        }
        @include media-breakpoint-down(md) {
            .btn {
              padding-left: 0.5rem;
              padding-right: 0.5rem;
              font-size: $font-size-sm;
            }
        }
        @include media-breakpoint-down(sm) {
            flex-direction: column;
        }

        .form-group {
            flex: 2;
            position: relative;
            @include media-breakpoint-down(sm) {
                width: 100%;
            }

            label {
                color: $secondary !important;
                margin-bottom: 0.2rem;
            }

            .form-control {
                outline: none !important;
                box-shadow: none !important;
            }
        }

        .tooltip {
            position: absolute;
            border-top: 3px solid $danger;
            border-radius: $border-radius;
            background-color: $light;
            color: $danger;
            left: 50%;
            top: 0;
            opacity: 1 !important;
            box-shadow: $box-shadow;
            padding: 0.5rem 1rem;
            min-width: 12rem;
            transform: translate(-50%, calc(-100% + 0.5rem));

            &:after {
                content: '';
                position: absolute;
                width: 0;
                height: 0;
                border-style: solid;
                border-width: 0.5rem 0.5rem 0 0.5rem;
                border-color: $light transparent transparent transparent;
                bottom: 0;
                left: 50%;
                transform: translate(-50%, 0.3rem);
                transition: all 0.3s ease-in-out;
            }
        }

        .gender-group {
            display: flex;
            flex-direction: row;
            flex: 2;
            position: relative;
            @include media-breakpoint-down(sm) {
                width: 100%;
                flex-wrap: wrap;
            }

            .btn {
                flex: 1;
                white-space: nowrap;
                outline: none !important;
                box-shadow: none !important;

                &:last-child {
                    margin-right: 0 !important;
                }
            }

            .tooltip {
                top: -1rem;
                left: 50%;
                transform: translate(-50%, -100%);
            }

            &__tooltip {
                position: absolute;
                top: -1rem;
                left: 50%;
                transform: translate(-50%, -100%);
                box-shadow: $box-shadow;
                padding: 1rem 0;
                border-radius: $border-radius;
                background-color: $light;
                z-index: 1060;
                border-top: 5px solid $primary;

                @include media-breakpoint-down(sm) {
                    position: relative;
                    top: initial;
                    left: initial;
                    transform: none;
                    margin-top: 1rem;
                    box-shadow: none;
                    border: 1px solid $border-color;
                    width: 100%;
                }

                &__item {
                    padding: 1rem;
                    border: 2px dashed $dark;
                    border-radius: $border-radius;
                    margin: 0 0.5rem;
                    cursor: pointer;
                    transition: all 0.3s ease;
                    min-width: 5rem;
                    display: flex;
                    align-items: center;
                    justify-content: center;
                    @include media-breakpoint-down(sm) {
                        min-width: 1rem;
                        width: initial !important;
                        padding: 0.5rem;
                    }

                    &--active {
                        border-color: transparent;
                        background-color: lighten($primary, 20%);
                    }

                    img {
                        width: 100%;
                        object-fit: contain;
                        transition: all 0.3s ease;
                        margin: auto;
                        @include media-breakpoint-down(sm) {
                            width: 3rem;
                            height: 3rem;
                        }
                    }

                    &:not(.gender-group__tooltip__item--active):hover {
                        background-color: rgba($primary, 0.1);

                        img {
                            transform: scale(1.1);
                        }
                    }
                }

                &:after {
                    position: absolute;
                    width: 0;
                    height: 0;
                    border-style: solid;
                    border-width: 0.5rem 0.5rem 0 0.5rem;
                    border-color: $light transparent transparent transparent;
                    bottom: 0;
                    left: 50%;
                    transform: translate(-50%, 0.4rem);
                    transition: all 0.3s ease-in-out;

                    @include media-breakpoint-up(md) {
                        content: '';
                    }
                }

                &--start:after {
                    transform: translate(calc(-50% - 75px), 0.4rem);
                }

                &--end:after {
                    transform: translate(calc(-50% + 75px), 0.4rem);
                }
            }
        }

        .btn--right {
            flex: 1.5;
        }
    }
</style>
